--ein game von knorke
gameVersion = "30.04.2024"
local ALL_LEVELS_UNLOCKED = false --cheat/debug
TIME = {
UNPLAYED = -2,
FAIL = -1,
BRONZE = 1,
SILVER = 2,
GOLD = 3,
CHEAT = -666,
}

TXT = require "txt"
TXT.init()
changeLanguage ("DE")

local lg = love.graphics
local kb = love.keyboard
local sin = math.sin
local cos = math.cos
local font_main = love.graphics.newFont("font//RubikMonoOne-Regular.ttf", 20 )
lg.setFont (font_main)

local TILESIZE = 40
local lvl = 0
local gameSpeed = 0.2
local pathCanvas = lg.newCanvas (800,600)
local gridCanvas = lg.newCanvas (800,600)
local levelTimer = 0
local global_t = 0
local global_dt = 0
local gameStatus = "INGAME" -- "FINISHED" "MENU"
local GOAL = 1
local GOALHIT = 2
local EMPTY = 0
local AVOID = 3

local menuTriedToStartLockedTimer = 0
local cheatInputTimer = 0
local showStars = true

--[[
local TIME_S = {
	[TIME.UNPLAYED] = TXT.time_unplayed,
	[TIME.FAIL] = TXT.time_tooslow,
	[TIME.BRONZE] = TXT.time_bronze,
	[TIME.SILVER] = TXT.time_silver,
	[TIME.GOLD] = TXT.time_gold
}
--]]

local grid =
{
}

local arm =
{
--[[
a = {0,0}, --player input 0 to 2*pi
p = {},
startx=400,
starty=300,
endx = 0,
endy = 0, 
gridx = 0,
gridy = 0,
--]]
}

local sounds = { 
	goalHit = love.audio.newSource("sound//boink.wav", "static")
	}


local levelFinishTimes = {} -- [levelNumber]=.time .rating

local spriteBatch , quadBrick

function gridInit()
	grid = {}
	grid.missingGoals = 0
	grid.totalGoals = 0
	for x=1,800/TILESIZE,1 do
		grid[x]= {}
		for y=1, 600/TILESIZE,1 do
			grid[x][y] = EMPTY
	--		if math.random (0,100)<50 then gridAddGoal(x,y) end
		end
	end
end

function gridSetFromDataString (data)
	print ("gridSetFromDataString")
	if data == nil then
		print ("data==nil")
		gridAddGoal(1,1)
		gridAddGoal(2,2) 
 		gridAddGoal(3,3)
 		return 
	end
	local s = data.s
	local offsetx = data.offsetx
	local offsety = data.offsety
	for line=1, #s, 1 do
		local sline = s[line]
		for row = 1, #sline, 1 do 
			local cs = sline:sub(row,row)
			if cs == "#" then
				gridAddGoal(row+offsetx , line+offsety) 
			--	print (line .. ":"..row)
			end
		end
	end
	grid.missingGoals = grid.totalGoals
end

function gridAddGoal (x,y)
	if grid[x][y] == EMPTY then
		grid.totalGoals = grid.totalGoals +1
		grid[x][y] = GOAL
	end
end

function drawGrid()
	spriteBatch:clear()
	for x=1,800/TILESIZE,1 do
		for y=1, 600/TILESIZE,1 do
			if grid[x][y] ~= EMPTY then
				lg.setColor (0.2, 0.2, 0.2 ,1)
				lg.circle ("line",x * TILESIZE,y * TILESIZE,28,20)
				--lg.circle ("line",dx,dy,10,4)
				local dx = (x * TILESIZE) -- - (TILESIZE/2)
				local dy = (y * TILESIZE) -- - (TILESIZE/2)
				local squaredx = dx - (TILESIZE/2)
				local squaredy = dy - (TILESIZE/2)		

						--[[
				--lg.circle ("line", dx,dy,TILESIZE/2, 10)
				local style = "line"
				lg.setColor (0,0,1,1)
				if grid[x][y] == GOALHIT then lg.setColor (1,1,0,0.5) style = "fill" end

				if x==arm.gridx and y==arm.gridy then style = "fill" lg.setColor (1,0,1,1) end
				lg.rectangle (style ,dx-(TILESIZE/2), dy-(TILESIZE/2),TILESIZE,TILESIZE)
				lg.setColor (1,1,1,1)
				lg.print (x..":"..y, dx-10,dy)
				--]]
				if grid[x][y] == GOALHIT then
					spriteBatch:add(quadGoalHit, squaredx,squaredy)
				end
				if grid[x][y] == GOAL then
					spriteBatch:add(quadGoal, squaredx,squaredy)
				end
								lg.setColor (1,1,1,1)



			end
		end
	end
	love.graphics.draw(spriteBatch,0,0)

end


function gameInit()
	print ("gameInit()")
	levelTimer = -3
	changeGameStatus ("MENU")
	for i = 0, #level, 1 do
		levelFinishTimes[i] = {rating=TIME.UNPLAYED}
		if not level[i].goldTime then level[i].goldTime = 10 end 
	end
end

function cheatGiveGoldAllLevels ()
	for i = 1, #level, 1 do
		levelFinishTimes[i] = {rating=TIME.GOLD, time = 100}
	end
end

function cheatUnlockAllLevels ()
	for i = 1, #level, 1 do
		if levelFinishTimes[i].rating == TIME.UNPLAYED then
			levelFinishTimes[i] = {rating=TIME.CHEAT, time = 100}
		end
	end
	ALL_LEVELS_UNLOCKED = true
end

function gameStartLevel (levelNr)
	print ("gameStartLevel() :" .. (levelNr or "nil"))
	if not level[levelNr] then changeGameStatus("MENU") return end
	gridInit()
	armInit()
	gridSetFromDataString (level[levelNr].gridData)
	levelTimer = -3
	changeGameStatus("INGAME")
	lg.setCanvas(pathCanvas)
	lg.clear( )
	lg.setCanvas()
end

function love.load()
	printTXT ("DE")
	love.window.setMode(800,600, {vsync=false, fullscreen=false})
	
	local image = love.graphics.newImage("gfx//blocks.png")
	spriteBatch = love.graphics.newSpriteBatch(image)
	quadGoal   = love.graphics.newQuad(0,  0,  40, 40, image:getDimensions())
	quadGoalHit   = love.graphics.newQuad(40,  0,  40, 40, image:getDimensions())
	quadAvoid   = love.graphics.newQuad(80,  0,  40, 40, image:getDimensions())

	lg.setLineWidth (5)
	gameInit()
	--cheatUnlockAllLevels()
end

function love.update(dt)
	global_dt = dt
	global_t = global_t +dt
	if showStars then updateStars  () end
	if gameStatus == "INGAME" then 
		--print ("gameStatus == INGAME")
		ingameInput (dt)
		armCalc()
		gridCheckHit (arm.gridx, arm.gridy)
		if grid.missingGoals <= 0 then --finished level 
			changeGameStatus("FINISHED") 
			if levelTimer < (levelFinishTimes[lvl].time or 999999 ) then levelFinishTimes[lvl].time = levelTimer end
			local rating = rateLevelTime (levelTimer, level[lvl].goldTime)
			if (rating > (levelFinishTimes[lvl].rating or -1)) then 
				levelFinishTimes[lvl].rating = rating 
			end 
		else
			levelTimer=levelTimer+dt
		end
	end

	if gameStatus == "MENU" then
		if menuTriedToStartLockedTimer > 0 then 
			menuTriedToStartLockedTimer = menuTriedToStartLockedTimer -dt
		end
	end
end

function gridCheckHit (tx,ty)
	if tx<1 or tx>40 then return end
	if ty<1 or ty>40 then return end
	--print (arm.gridx, " - " , arm.gridy)
	if grid[tx][ty] == GOAL then 
		grid[tx][ty] = GOALHIT
		grid.missingGoals = grid.missingGoals -	1
		love.audio.play(sounds.goalHit)
	end
end


function rateLevelTime (playerTime, goldTime)
	if playerTime < goldTime then return TIME.GOLD end
	if playerTime < goldTime*1.4 then return TIME.SILVER end
	if playerTime < goldTime*2 then return TIME.BRONZE end
	return TIME.FAIL
end

function love.draw()
	if showStars then drawStars () end
	--lg.print (gameStatus.."|flicker:"..math.random (0,1),10,10)
	if gameStatus == "INGAME" or gameStatus == "FINISHED" then
		--print ("ingame draw")
		lg.setColor (1,1,1,1)
		lg.print ("lvl:"..lvl, 0,0)
		drawGrid()
		drawPathCanvas()
		lg.setColor (1,1,1,1)
		lg.setColor (1,1,1,1)
		lg.draw (pathCanvas,0,0)
		drawArm()
		if gameStatus == "INGAME" then drawControlls() end
		lg.print (grid.totalGoals-grid.missingGoals.."/"..grid.totalGoals,250,10)
		if levelTimer < 0 then
			lg.rectangle ("fill",300,200-5, 240 * (-levelTimer/3),22+10)
			lg.setColor (1,0,0,1)
			lg.rectangle ("fill",300,200, 240,22)
			lg.setColor (1,1,1,1)
			lg.print ("let's go! " ..math.floor(-levelTimer*10)/10 , 300,200)
		else
			lg.print (TXT.TIME..":"..round (levelTimer,2), 0,20)
			if levelFinishTimes[lvl].rating ~= TIME.UNPLAYED then
				lg.print (TXT.BEST_TIME..":"..round (levelFinishTimes[lvl].time,2),0,40)
			end
		end
		if gameStatus == "FINISHED" then finishedDraw () end
	end
	if gameStatus == "MENU" then
		menuDraw()
	end
end

function finishedDraw ()
	lg.setColor (1,0,0,1)
	lg.rectangle ("fill", 150,200, 500,74)
	lg.setColor (1,1,1,1)
	lg.print (TXT.FINISHED_IN .." ".. round(levelTimer,4), 150,200)
	
	--lg.print (TXT.TIME_S[levelFinishTimes[lvl].rating], 200,225)
	
	drawFlashText (TXT.TIME_S[levelFinishTimes[lvl].rating], 150,225, {1,1,1},{1,0,1}, global_t)
	
	if levelFinishTimes[lvl].rating ~= TIME.FAIL then
		lg.setColor (1,0,0,1)
		lg.rectangle ("fill", 150,274, 500,30)
		lg.setColor (1,1,1,1)
		lg.print (TXT.SPACE_TRY_AGAIN, 150,250)
		lg.print (TXT.ENTER_NEXT_LEVEL, 150, 280)
	else
		lg.print (TXT.SPACE_TRY_AGAIN, 150,250)
		lg.print (TXT.NEED..": " .. level[lvl].goldTime*1.75, 400, 225)
	end
end

function ingameInput (dt)
	local d = dt * gameSpeed
	if gameStatus == "INGAME" then
		if levelTimer < 0 then return end
		if kb.isDown("q") or kb.isDown("up") then arm.a[1]=arm.a[1]-d*(arm.input[1].speed or 1) end
		if kb.isDown("w") or kb.isDown("down") then arm.a[1]=arm.a[1]+d*(arm.input[1].speed or 1) end
		if kb.isDown("o") or kb.isDown("left") then arm.a[2]=arm.a[2]-d*(arm.input[2].speed or 1) end
		if kb.isDown("p") or kb.isDown("right") then arm.a[2]=arm.a[2]+d*(arm.input[2].speed or 1) end
	end
end

function love.keyreleased (key, scancode)
	if  gameStatus == "MENU" then menuInput (key) end

end

function love.keypressed(key, scancode, isrepeat)
	if key == "l" then changeToNextLanguage() end
	if  gameStatus == "MENU" then
		--if key == "escape" then love.event.quit() end
		if key == "g" then cheatGiveGoldAllLevels() end
   end
   
	if gameStatus == "FINISHED" then
		if key =="space" then
			--if levelFinishTimes[lvl].rating ~= TIME.FAIL then lvl=lvl+1 end
			gameStartLevel (lvl)	
			return
		end 
		
		if key == "return" then
			if levelFinishTimes[lvl].rating ~= TIME.FAIL then lvl=lvl+1 end
			gameStartLevel (lvl)
			return 
		end
	end
	if gameStatus == "INGAME" and key == "space" then
		if levelTimer < 0 then levelTimer = 0 else gameStartLevel (lvl) end
	end
	if gameStatus == "INGAME" and key == "escape" then
		--gameStatus = "MENU"
		changeGameStatus ("MENU")
	end
end

function changeGameStatus (newStatus)
	if newStatus == "MENU" then
		menuTriedToStartLockedTimer = 0
	end
	gameStatus = newStatus
end

function armInit()
	print ("armInit()")
	arm =
	{
	a = {0,0},
	p = {},
	input = {},
	startx=400,
	starty=300,
	endx = 0,
	endy = 0, 
	gridx = 0,
	gridy = 0,
	}
	for i=1, #arm.a, 1 do
		arm.input[i] = {limitHigh=0, limitLow = 0}
	end
	if level[lvl].init then level[lvl].init() print ("level[lvl].init()") end

end

function armCalc()
	for i=1, #arm.input, 1 do
		
		if arm.a[i] < arm.input[i].limitLow then 
			if arm.input[i].wrapAround then
					arm.a[i] = arm.input[i].limitHigh
			else 
				arm.a[i] = arm.input[i].limitLow
			end 
		end
		if arm.a[i] > arm.input[i].limitHigh then 
			if arm.input[i].wrapAround then
					arm.a[i] = arm.input[i].limitLow
			else 
				arm.a[i] = arm.input[i].limitHigh
			end 
		end
		
	end

	level[lvl].calc()
	
	local x,y = arm.endx,arm.endy--love.mouse.getPosition()
	--local x,y = love.mouse.getPosition() or 1,1

--	local x,y = love.mouse.getPosition()
	arm.gridx = math.ceil ((x / TILESIZE )-0.5)
	arm.gridy = math.ceil ((y / TILESIZE )-0.5)

end

function drawArm ()
--	for i=1, #arm.a, 1 do
--	print (i)
--		lg.line (arm.p[i-1].x, arm.p[i-1].y,  arm.p[i].x, arm.p[i].y)
--	end
	if arm.p[1] then
	level[lvl].draw()
	drawArmEndPoint()
	end
end

function drawArmEndPoint ()
	lg.circle ("line", arm.endx, arm.endy, 10,8)
	  lg.arc( "line", arm.endx, arm.endy, 10, levelTimer*20, math.pi+levelTimer*20,8 )
end

local pathColors = {
{0,255,255},
{0,255,0},
{0,0,0},

}
function drawPathCanvas()
	lg.push()
	--lg.scale(1/Sys.scaleX, 1/Sys.scaleY)
	lg.setCanvas(pathCanvas)
	--love.graphics.setBlendMode( "add")
	local ci = (math.ceil (levelTimer*100) %#pathColors)+1
	lg.setColor (pathColors [ci])
	--love.graphics.setBlendMode("alpha")
	lg.circle ("fill", arm.endx, arm.endy, 4,6)

	lg.setCanvas ()
	lg.pop()
end





function drawControlls()
	local length=200
	local dy=20
	local dx=350
	local keys = {"[q][w]", "[o][p]"}
	for i=1, #arm.input, 1 do
		local range = math.abs(arm.input[i].limitLow - arm.input[i].limitHigh)
		local abs_a = arm.a[i] - arm.input[i].limitLow
		lg.rectangle ("line", dx,dy, length, 10)
		lg.rectangle ("fill", dx,dy, abs_a*length * (1/range), 10)
		lg.print (keys[i]..round(arm.a[i],2), dx+length+20,dy-8)
		dy=dy+25
	end
end

--winkel > 360° "kürzen"
function real_a (a)
local n =  a / (2*math.pi)
if (math.abs (n) > 1) then a = a - (math.floor(n)*math.pi*2) end
return a
end


function wrapAround (a, limit)
local n =  a / (2*limit)
if (math.abs (n) > 1) then a = a - (math.floor(n)*limit) end
return a
end

function menuDraw(dt)
	--"Abtasten mit dem Tastorgan
	lg.print (TXT.MENU_TITLE.."\t"..gameVersion..TXT.MENU_INSTRUCTION, 10,10)
	--lg.print ("level:" .. lvl, 100,100)
	lg.print ("ingame keys: [q][w] [o][p]\nprogress is not saved on exit",10,520)
	local dx=100
	local dy=100
	lg.print (TXT.BEST_TIMES..":",dx,dy)
	local totalTime = 0
	for i=0, #level, 1 do
		dy=dy+20
		local si = i
		if i < 10 then si="0"..si end
		--if i == 0 then si = "00 TUTORIAL" end
		--local arrowAnim = {'>>--' , '->>-' , '-->>','--->',  '>-->' }
		local arrowAnim = {"--->", "-\\-> ", "-|->", "-/->"}  
		local arrow = arrowAnim[(math.ceil(global_t*5)%#arrowAnim)+1]
		lg.print (si..") " .. ((round(levelFinishTimes[i].time,4) or ".....") .. " - " .. (TXT.TIME_S[levelFinishTimes[i].rating] or "none")), dx,dy)
		if i==lvl then lg.print (arrow, dx-70,dy) end
		if levelFinishTimes[i].rating > 0 then totalTime = totalTime + levelFinishTimes[i].time end
	end
	lg.print (TXT.TOTAL_TIME..":"..totalTime,dx,dy+40)
	
	if menuTriedToStartLockedTimer > 0 then
		lg.setColor (0,0,0,0.5)
		lg.rectangle ("fill",0,0, 800,600)
		drawFlashText (TXT.LOCKED_LEVEL, 250,225, {1,0,0},{1,0,1}, global_t*2)
		lg.setColor (1,1,1,1)
	end
	local sl = ""
	for i=1, #TXT_languagesArray, 1 do
		local marker = " "
		if i == TXT.activeLanguage.i then marker = "|" end
		sl=sl..marker..TXT_languagesArray[i]..marker.."\n"
	end
	lg.print ("[L]", 660,370)
	lg.print (sl, 650,400)
end

function menuInput (key)
	if key=="q" or key == "up" then lvl=lvl-1 end
	if key=="w" or key == "down" then lvl=lvl+1 end
	if lvl < 0 then lvl=0 end
	if lvl > 16 then lvl=16 end
	if key=="space" then 
		if ALL_LEVELS_UNLOCKED or lvl==0 or level[math.floor(lvl)] and (math.floor(lvl)==1 or levelFinishTimes[math.floor(lvl-1)].rating > 0) then
			lvl = math.floor(lvl)
			gameStartLevel (lvl)
		else
			menuTriedToStartLockedTimer = 3
			--print (levelFinishTimes[math.floor(lvl)].rating )
		end 
	end
	if key == "f" then 
		cheatInputTimer = cheatInputTimer + global_t 
		if cheatInputTimer > 3 then cheatUnlockAllLevels() cheatInputTimer = 0 end
	else
		cheatInputTimer = 0
	end
end




function round(num, numDecimalPlaces)
	if num==nil then return nil end
	local mult = 10^(numDecimalPlaces or 0)
	return math.floor(num * mult + 0.5) / mult
end

function drawFlashText (text, x,y, color1,color2, t)
	local n = math.floor (t*10)%#text
	local s = string.sub(text, n, n)
	love.graphics.setColor(color1 or {1,0,0,1})
	love.graphics.print(text, x,y)	
	love.graphics.setColor(color2 or {0,1,1,1})
	love.graphics.print(string.rep(" ",n-1)..s, x,y)	
end

--------- levels ---------
---
level = {}


--easy linear tutorial
level[0] = {
	goldTime = 10,
	init = function()
		arm.input = {
		[1] = {limitHigh=300, limitLow = 0, speed=500},  --y
		[2]=  {limitHigh=200, limitLow = -200, speed=500, wrapAround=false} ,--x
		}
		arm.startx=400
		arm.starty=200
		arm.a= {150,0}
	end
	,
	gridData = {
	s =			{	"###-#---",
					"#---#---",
					"----#-##",
					"##-#-#--#",
					"----#--#",
					"#---#-##",
					"###-#---",
					},
	offsetx=5,
	offsety=5,
	}
	,
	draw = function()
		lg.line (arm.startx+arm.input[2].limitLow, arm.p[1].y,
				 arm.startx+arm.input[2].limitHigh, arm.p[1].y)
		
		lg.line (arm.startx+arm.input[2].limitLow, arm.starty,
				 arm.startx+arm.input[2].limitLow, arm.p[1].y)	

		lg.line (arm.startx+arm.input[2].limitHigh, arm.starty+arm.input[1].limitHigh,
				 arm.startx+arm.input[2].limitHigh, arm.p[1].y)	
	
		lg.print ("<--[O] [P]-->",300,150)
		local tx=100
		local ty=350
		lg.print ("[W]\n |\n v",tx,ty)
		lg.print ("[Q]",tx,ty-45)
		lg.print ("|\nv ",tx+35,ty-50,math.pi) 
		lg.print ("[space] restart", 20,550)
	end
	,
	calc = function()
		arm.p = {}
		arm.p[0] = {x=arm.startx, y=arm.starty}
		arm.p[1] = {x=arm.startx, y=arm.starty + arm.a[1]}
		arm.p[2] = {x=arm.p[1].x + arm.a[2] , y=arm.p[1].y}
		arm.endx=arm.p[2].x
		arm.endy=arm.p[2].y
	end
}

-- arm with 2 rotation joints
level[1] = {
	goldTime = 8,
	init = function()
		arm.a={1,0}
		arm.startx=150
		arm.starty=400+40
		arm.input = {
		[1] = {limitHigh=6.5, limitLow = 4.5, speed=4, wrapAround=false}, 
		[2]=  {limitHigh=2*math.pi, limitLow = 0, speed=10, wrapAround=true} ,
		}
	end
	,
	gridData = {
	s =			{	"---#--------",
					"---#--------",
					"-###--------",
					"-##---------",
					"-##---------",
					"-----###----",
					"-----###--#-",
					"----------#-",
					"-----###--#-",
					"-----###--##",
					},
	offsetx=1,
	offsety=1,
	}
	,
	draw = function()
		local p = arm.p
		for i=1, #arm.a, 1 do
			lg.line (arm.p[i-1].x, arm.p[i-1].y,  arm.p[i].x, arm.p[i].y)
		end
		lg.circle ("line", p[1].x,p[1].y, 4)
		lg.arc ("line","open", p[0].x,p[0].y, 50, arm.input[1].limitLow, arm.input[1].limitHigh)
	end
	,
	calc = function()
		arm.p = {}
		arm.p[0] = {x=arm.startx, y=arm.starty}
		local suma = 0
		for i=1, #arm.a, 1 do
			suma = suma + arm.a[i]
			arm.p[i] = {}
			arm.p[i].x = arm.p[i-1].x + cos(suma) * (120*(3-i))
			arm.p[i].y = arm.p[i-1].y + sin(suma) * (120*(3-i))
		end
		arm.endx=arm.p[2].x
		arm.endy=arm.p[2].y
	end
}

level[2] = {
	goldTime = 6, --4.47
	init = level[1].init
	,
	gridData = {
	s =			{	"------------",
					"------------",
					"------------",
					"----#-#-----",
					"-----#-#----",
					"----#-#-#---",
					"-----#-#----",
					"------#-----",
					"-----#-#----",
					"------#-#---",
					},
	offsetx=1,
	offsety=1,
	}
	,
	draw = level[1].draw
	,
	calc = level[1].calc
}

--linear y-axis, rotation joint
level[3] = {
	goldTime = 10,
	init = function()
		arm.input = {
		[1] = {limitHigh=1, limitLow = -1, speed=3}, 
		[2]=  {limitHigh=2*math.pi, limitLow = 0, speed=5, wrapAround=true} ,
		}

	end
	,
	gridData = {
	s =			{	"#####",
					"#---#",
					"#---#",
					"#####",
					"##-##",
					"##-##",
					"##-##",
					},
	offsetx=7,
	offsety=5,
	}
	,
	draw = function()
		local p = arm.p
		for i=1, #arm.a, 1 do
			lg.line (arm.p[i-1].x, arm.p[i-1].y,  arm.p[i].x, arm.p[i].y)
		end
		lg.line (arm.startx, arm.starty-100, arm.startx, arm.starty+100)
		lg.circle ("line", p[1].x,p[1].y, 10)
	end
	,
	calc = function()
		arm.p = {}
		arm.p[0] = {x=arm.startx, y=arm.starty}
		arm.p[1] = {x=arm.startx, y=arm.starty + arm.a[1]*100}
		arm.p[2] = {x=arm.p[1].x+(cos(arm.a[2])*130) , y=arm.p[1].y+(sin(arm.a[2])*130)}
		arm.endx=arm.p[2].x
		arm.endy=arm.p[2].y
	end
}

level[4] = {
	goldTime = 10,
	init = level[3].init
	,
	gridData = {
	s =			{	"#----#",
					"##--##",
					"#----#",
					"######",
					"-###--",
					"---##-",
					"---##-",
					},
	offsetx=6,
	offsety=5,
	}
	,
	draw = level[3].draw
	,
	calc = level[3].calc
}
--vertical axis, rotate
level[5] = {
	goldTime = 12,
	init = function()
		arm.a={5, 0, 0}
		arm.startx=400
		arm.starty=350
		arm.input = {
		[1] = {limitHigh=7, limitLow = 2.5, speed=5, wrapAround=false}, 
		[2]=  {limitHigh=3, limitLow = -3, speed=5, wrapAround=false} ,
		}
	end
	,
	gridData = {
	s =			{	"---------",
					"--#------",
					"-##----#-",
					"-##--##--",
					"##---#---",
					"---##----",
					"--###--##",
					"---#---##",
					"---#---##",
					"---#-----",
					},
	offsetx=4,
	offsety=3,
	}
	,
	draw = function()
		local p = arm.p
		for i=1, #arm.a, 1 do
			
			if arm.p[i] then lg.line (arm.p[i-1].x, arm.p[i-1].y,  arm.p[i].x, arm.p[i].y) 
					lg.circle ("line", p[i].x,p[i].y, 10,4)

			end
		end
		lg.arc ("line","open", p[0].x,p[0].y, 50, 2.5,7)
	end
	,
	calc = function()
		arm.p = {}
		arm.p[1] = {}
		arm.p[2] = {}
		arm.p[3] = {}
		arm.p[0] = {x=arm.startx, y=arm.starty}
		local suma = 0
		--[[
		for ai=1, #arm.a, 1 do

			suma = suma + arm.a[ai]
			local i =  1+math.floor((ai-1)%2)
										print (i)

			arm.p[ai] = {}
			arm.p[ai].x = arm.p[ai-1].x + (cos(suma*(2-i)) * 100)
			arm.p[ai].y = arm.p[ai-1].y + (sin(suma*(2-i)) * 100)
		end
		--]]
		
			arm.p[1].x = arm.p[0].x + (cos(arm.a[1]) * 50)
			arm.p[1].y = arm.p[0].y + (sin(arm.a[1]) * 50)
		
			arm.p[2].x = arm.p[1].x + (cos(arm.a[2] + arm.a[1]) * 100)
			arm.p[2].y = arm.p[1].y + (sin(arm.a[2] + arm.a[1]) * 100)
			
			arm.p[3].x = arm.p[2].x + (cos(arm.a[1] + arm.a[2]*2) * 50)
			arm.p[3].y = arm.p[2].y + (sin(arm.a[1] + arm.a[2]*2) * 50)
		
		arm.endx=arm.p[3].x
		arm.endy=arm.p[3].y
	end
}

level[6] = {
	goldTime = 10,
	init = level[5].init
	,
	gridData = {
	s =			{	"----------",
					"---##-----",
					"--#----#--",
					"--#----#-#",
					"###----#-#",
					"--#----#-#",
					"--#----#-#",
					"--#---##-#",
					"-##---##--",
					"----------",
					},
	offsetx=4,
	offsety=3,
	}
	,
	draw = level[5].draw
	,
	calc = level[5].calc
}

--rotation joint, variable arm length. (full circle, change radius)
level[7] = {
	goldTime = 14,
	init = function()
		arm.a={2.7,0.2}
		arm.startx=400
		arm.starty=300
		arm.input = {
		[1]=  {limitHigh=2*math.pi, limitLow = 0, speed=8, wrapAround=true} ,
		[2] = {limitHigh=1, limitLow = 0, speed=4, wrapAround=false}, 

		}
	end
	,
	gridData = {
	s =			{	"--#####----",
					"----###--##",
					"----###--##",
					"-----##--##",
					"-----######",
					"-----######",
					"-----##--##",
					"---------##",
					"-###----###",
					"-##-----#--",
					},
	offsetx=4,
	offsety=2,
	}
	,
	draw = function()
		local p = arm.p
		--for i=1, #arm.a, 1 do
			--lg.line (arm.p[i-1].x, arm.p[i-1].y,  arm.p[i].x, arm.p[i].y)
		--end
		lg.circle ("line", p[0].x,p[0].y, arm.a[2]*220)
		lg.circle ("line", p[1].x,p[1].y, 10,4)
		lg.line (p[0].x,p[0].y,  p[1].x,p[1].y)
	--	lg.line (
		--lg.arc ("line","open", p[0].x,p[0].y, 50, arm.input[1].limitLow, arm.input[1].limitHigh)
	end
	,
	calc = function()
		arm.p = {}
		arm.p[0] = {x=arm.startx, y=arm.starty}
		arm.p[1] = {x= (arm.p[0].x+(cos(arm.a[1])*arm.a[2]*220)),
					y=arm.p[0].y+(sin(arm.a[1])*arm.a[2]*220)
					}
		arm.p[2] = arm.p[1]
		arm.endx=arm.p[2].x
		arm.endy=arm.p[2].y
	end
}

--rotation joint, variable arm length. (full circle, change radius)
level[8] = {
	goldTime = 9,
	init = level[7].init
	,
	gridData = {
	s =			{	"----------",
					"---###----",
					"--#---#--",
					"---###---",
					"--#----#--",
					"-#-#------",
					"--#-----#--",
					"----#-##--",
					"--##-##---",
					"----#-----",
					},
	offsetx=4,
	offsety=3,
	}
	,
	draw = level[7].draw
	,
	calc = level[7].calc
}



--half-circle, arm expands to inside
level[9] = {
	goldTime = 15,
	init = function()
		arm.a={-1,200}
		arm.startx=400
		arm.starty=270
		arm.input = {
		[1]=  {limitHigh=0, limitLow = -4, speed=6, wrapAround=false} ,
		[2] = {limitHigh=400, limitLow = 0, speed=600, wrapAround=false}, 

		}
	end
	,
	gridData = {
	s =			{	"-----------",
					"-----------",
					"---########",
					"---########",
					"-----------",
					"--------###",
					"-###----###",
					"-###-------",
					"-----###---",
					"-----###---",
					},
	offsetx=4,
	offsety=2,
	}
	,
	draw = function()
		local p = arm.p
		lg.circle ("line", p[0].x,p[0].y, 10,4)
		lg.line (p[0].x,p[0].y,  p[1].x,p[1].y)
		lg.arc ("line","open", arm.startx,arm.starty, 200, arm.input[1].limitLow, arm.input[1].limitHigh)
	end
	,
	calc = function()
		arm.p = {}
		arm.p[0] = {x= (arm.startx+(cos(arm.a[1])*200)),
					y=arm.starty+(sin(arm.a[1])*200)
					}
		arm.p[1] = {x=arm.p[0].x - cos(arm.a[1])* arm.a[2], y=arm.p[0].y- sin(arm.a[1])* arm.a[2]}		
		arm.p[2] = arm.p[1]
		arm.endx=arm.p[2].x
		arm.endy=arm.p[2].y
	end
}

level[10] = {
	goldTime = 11,
	init = function()
		arm.a={-2,20}
		arm.startx=400
		arm.starty=270
		arm.input = {
		[1]=  {limitHigh=0, limitLow = -4, speed=6, wrapAround=false} ,
		[2] = {limitHigh=400, limitLow = 0, speed=600, wrapAround=false}, }
		
		end
			,
	gridData = {
	s =			{	"-#---------",
					"-#--####---",
					"-#--#--#--",
					"-####--#---",
					"-------#---",
					"---#####---",
					"---#-------",
					"-###----#--",
					"-#-----##--",
					"-#######---",
					},
	offsetx=5,
	offsety=1,
	}
	,
	draw = level[9].draw
	,
	calc = level[9].calc
}


local function sinCurve (x, freq,amp)
	return math.sin (x*freq)*amp
end

--sinus
level[11] = {
	goldTime = 10, --8.50
	init = function()
		arm.input = {
		[1] = {limitHigh=0.2, limitLow = -0.2, speed=0.5},  --freq
		[2]=  {limitHigh=420, limitLow = 0 , speed=1000, wrapAround=false} ,--x
		}
		arm.startx=130
		arm.starty=350
		arm.a= {0,0}
	end
	,
	gridData = {
	s =			{	"####--###",
					"--##--##-",
					"---####--",
					"----##---",
					"-#-------",
					"-#----##-",
					"##----##-",
					"---------",
					"---------",
					"----##---",
					},
	offsetx=5,
	offsety=3,
	}
	,
	draw = function()
		lg.setColor (1,1,1,1)
		lg.circle ("line", arm.startx,arm.starty, 10,4)

		--***maybe cache?
		for i=1,420,2 do
			lg.circle ("fill", arm.startx+i, arm.starty+sinCurve(i, arm.a[1]/10,200), 4,5)
		end
	end
	,
	calc = function()
		arm.endx = arm.startx + arm.a[2]
		arm.endy = arm.starty + sinCurve(arm.a[2], arm.a[1]/10,200)
		arm.p[1] = {}
	end
}

----sinus 2
level[12] = {
	goldTime = 10, --9.09
	init = level[11].init
	,
	gridData = {
	s =			{	"------###",
					"-------#",
					"-#-#--###",
					"-###-----",
					"-#-#-----",
					"---------",
					"-----###-",
					"#--#--#--",
					"####-###",
					"#--#-----",
					"---------",
					},
	offsetx=5,
	offsety=3,
	}
	,
	draw = level[11].draw
	,
	calc = level[11].calc
}

--circles intersect


function Intersect2Circles( A, B)
  -- A, B = [ x, y ]
  -- return = [ Q1, Q2 ] or [ Q ] or [] where Q = [ x, y ]
  local AB0 = B.x - A.x;
  local AB1 = B.y - A.y;
  local c = math.sqrt( AB0 * AB0 + AB1 * AB1 )
  if (c == 0) then
    --no distance between centers
    return nil
  end
  local x = (A.r*A.r + c*c - B.r*B.r) / (2*c)
  local y = A.r*A.r - x*x;
  if (y < 0) then
    -- no intersection
    return nil
  end
  if (y > 0) then y = math.sqrt(y) end
  -- compute unit vectors ex and ey
  local ex0 = AB0 / c;
  local ex1 = AB1 / c;
  local ey0 = -ex1;
  local ey1 =  ex0;
  local Q1x = A.x + x * ex0;
  local Q1y = A.y + x * ex1;
  if (y == 0) then
    -- one touch point
    return { Q1x, Q1y }
  end
  --two intersections
  local Q2x = Q1x - y * ey0
  local Q2y = Q1y - y * ey1
  Q1x = Q1x + y * ey0
  Q1y = Q1y + y * ey1
  return { Q1x, Q1y }, { Q2x, Q2y }
end

level[13] = {
	goldTime = 11,
	init = function()
		arm.input = {
		[1] = {limitHigh=310, limitLow = 50, speed=400, len=220},  --y
		[2]=  {limitHigh=240, limitLow = -200, speed=400, len=260, wrapAround=false} ,--x
		}
		arm.startx=250
		arm.starty=260
		arm.a= {250,0}
	end
	,
	gridData = {
	s =			{	"###-----",
					"#-------",
					"--------",
					"-----#--",
					"---###--",
					"--------",
					"---##---",
					"---#----",
					"---#----",
					"--------",
					"----#---",
					"--###---",
					},
	offsetx=5,
	offsety=1,
	}
	,
	draw = function()
		--x axis
		lg.line (arm.startx+arm.input[2].limitLow, arm.starty,
				 arm.startx+arm.input[2].limitHigh, arm.starty)
		--y axis
		lg.line (arm.startx, arm.starty + arm.input[1].limitLow,
				 arm.startx, arm.starty + arm.input[1].limitHigh)
		
		--lg.line (arm.startx+arm.input[2].limitLow, arm.starty,
		--		 arm.startx+arm.input[2].limitLow, arm.p[1].y)	
		
		lg.circle ("line",arm.p[1].x,arm.p[1].y,10,4)
		--lg.circle ("line",arm.p[1].x, arm.p[1].y, arm.input[1].len)


		lg.circle ("line",arm.p[2].x,arm.p[2].y,10,4)
		--lg.circle ("line",arm.p[2].x,arm.p[2].y, arm.input[2].len)


		--lg.circle ("line",arm.startx, arm.starty,12,10)
		lg.line (arm.p[1].x,arm.p[1].y, arm.endx, arm.endy)
		lg.line (arm.p[2].x,arm.p[2].y, arm.endx, arm.endy)
		end
	,
	calc = function()
		arm.p = {}
		arm.p[1] = {x=arm.startx, y=arm.starty + arm.a[1],  r=arm.input[1].len}
		arm.p[2] = {x=arm.startx + arm.a[2], y=arm.starty,  r=arm.input[2].len}
		local Q1, Q2 = Intersect2Circles (arm.p[1], arm.p[2])
		if Q1 then 
			arm.endx=Q1[1]
			arm.endy=Q1[2]

		end
		
	end
}

level[14] = {
	goldTime = 15,
	init = level[13].init
	,
	gridData = {
	s =			{	"--------",
					"-###----",
					"-#-#----",
					"-###----",
					"------#-",
					"------#-",
					"---####-",
					"---#--#-",
					"---####-",
					"----#-#-",
					"----###-",
					"------#-",
					},
	offsetx=5,
	offsety=1,
	}
	,
	draw = level[13].draw
	,
	calc = level[13].calc
}

-- two rotation joints. player changes rotation speeds, joints rotate with set speed
level[15] = {
	goldTime = 25,
	init = function()
		arm.a={0,0} --rotation speed!
		arm.arot = {-math.pi/2,math.pi/2} --rotation angle!
		arm.startx=400
		arm.starty=300
		arm.input = {
		[1]=  {limitHigh=1, limitLow = -1, speed=5, wrapAround=false} ,
		[2] = {limitHigh=1, limitLow = -1, speed=5, wrapAround=false}, 
		}
	end
	,
	gridData = {
	s =			{	"-------------------",
					"-------------------",
					"-------------------",
					"---------------##--",
					"-----#------##-##--",
					"----###------#--#--",
					"---##-##----##--#--",
					"----###--------##--",
					"-----#--------##---",
					"-------------------",

					},
	offsetx=0,
	offsety=2,
	}
	,
	draw = function()
		for i=1, #arm.a, 1 do
			lg.line (arm.p[i-1].x, arm.p[i-1].y,  arm.p[i].x, arm.p[i].y)
		end
	end
	,
	calc = function()
		arm.p = {}
		arm.p[0] = {x=arm.startx, y=arm.starty}
		local suma = 0
		for i=1, #arm.arot, 1 do
			if math.abs(arm.a[i])>0.1 then arm.arot[i] = arm.arot[i] + arm.a[i] / 150 end
			suma = suma + arm.arot [i]
			arm.p[i] = {}
			arm.p[i].x = arm.p[i-1].x + cos(suma) * (90*(3.5-i))
			arm.p[i].y = arm.p[i-1].y + sin(suma) * (90*(3.5-i))
		end
		arm.endx=arm.p[2].x
		arm.endy=arm.p[2].y
	end
}

-- two rotation joints. player changes rotation speeds, joints rotate with set speed
level[16] = {
	goldTime = 15, --10.47
	init = level[15].init
	,
	gridData = {
	s =			{	"-------------------",
					"---------------##--",
					"--------------##---",
					"###----------##----",
					"--###-------##-----",
					"----###----##------",
					"------###-##-------",
					"--------###--------",
					"--------##---------",
					"-------------------",
				},
	offsetx=0,
	offsety=2,
	}
	,
	draw = level[15].draw
	,
	calc = level[15].calc
}

----stars


local stars = nil
function drawStars ()
	lg.setColor (0.5,0.5,0.5)
	
	for i=1,#stars do
		lg.circle ("fill",stars[i].x, stars[i].y, stars[i].r, 8)
		--lg.line (stars[i].x, stars[i].y, stars[i].x, stars[i].y - l)
	end
	lg.setColor (1,1,1,1)
end

function initStarfield()
	stars = {}
	for i=1,200,1 do
		initStar (i)
		stars[i].y=math.random(0,600)
		stars[i].x=math.random(0,800)
	end
end

function initStar (i)
	stars[i] = {}
	stars[i].x=math.random(200,600)
	stars[i].y=math.random(200,500)
	stars[i].xs=math.random(-25,25)
	stars[i].ys=math.random (-25,25)
	stars[i].r=math.random (1,5)
end

function updateStars (dt)
	--if #stars == 0 then
	--end
	if not stars then initStarfield () end
	for i=1,#stars do
		stars[i].y=stars[i].y + (stars[i].ys*global_dt)
		stars[i].x=stars[i].x + (stars[i].xs*global_dt)

		if stars[i].y > 600 or stars[i].y < 0 
			or stars[i].x > 800 or stars[i].x < 0 then initStar(i) 
		end
	
	if arm.endx and math.abs (stars[i].x-arm.endx)+math.abs(stars[i].y-arm.endy) < 60 then
		stars[i].ys=math.random (-200,200)
		stars[i].xs=math.random (-200,200)
	end
	
	end
end
