--language strings, translated
--print ("herzlich willkommen")
--print (TXT.welcome)
--local EN = require ("txt/EN")
TXT = {}  		--active language: TXT.hello = "hello"
TXT_LIST = {} 	--all languages: TXT.hello.DE = "hallo"
TXT_languagesArray = {} --[1]="EN" , [2]="DE", ... "EN"=1, "DE"=2

function TXT.init()
	addLanguage (require ("txt/EN"), "EN")
	addLanguage (require ("txt/DE"), "DE")
	addLanguage (require ("txt/FI"), "FI")
	addLanguage (require ("txt/UA"), "UA")
	addLanguage (require ("txt/FR"), "FR")
end

function addLanguage (langList, langName)
	for k,v in pairs (langList) do
		if not TXT_LIST[k] then TXT_LIST[k] = {} end
		TXT_LIST[k][langName] = v
	end
	TXT_languagesArray[#TXT_languagesArray+1] = langName
	TXT_languagesArray[langName] = #TXT_languagesArray
end

function changeLanguage (newLang)
	TXT = {}
	for i,v in pairs (TXT_LIST) do
		local s = v[newLang] or v["EN"] or "nix!"
		TXT[i] = shallowcopy(s)
	end
	TXT.activeLanguage = {s=newLang, i=TXT_languagesArray[newLang]}
end

function changeToNextLanguage()
	print ("changeToNextLanguage")
	print (TXT.activeLanguage.i ,"-",TXT.activeLanguage.s,#TXT_languagesArray)
	local i = TXT.activeLanguage.i+1
	if i > #TXT_languagesArray then i = 1 end
	local s = TXT_languagesArray[i]
	changeLanguage (s)
end

function printTXT (lang)
	print ("printTXT start-----")
	print ("language="..lang or "nil")
	for k,v in pairs (TXT_LIST) do
		if type(v[lang])=="string" then
			print (k..'="'.. (v[lang] or "nil")..'",')
		end
	end

	print ("printTXT end-------")
end

--http://lua-users.org/wiki/CopyTable
function shallowcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[orig_key] = orig_value
        end
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

return TXT
